import { HashMap } from "tstl/container/HashMap";
import { Entry } from "tstl/utility/Entry";
import { ICollection } from "../basic/ICollection";
import { CollectionEvent } from "../basic/CollectionEvent";
import "./internal";
export declare class HashMapCollection<Key, T> extends HashMap<Key, T> implements ICollection<Entry<Key, T>, HashMap<Key, T>, HashMap.Iterator<Key, T>, HashMap.ReverseIterator<Key, T>> {
    /**
     * @hidden
     */
    private dispatcher_;
    clear(): void;
    /**
     * @hidden
     */
    protected _Handle_insert(first: HashMap.Iterator<Key, T>, last: HashMap.Iterator<Key, T>): void;
    /**
     * @hidden
     */
    protected _Handle_erase(first: HashMap.Iterator<Key, T>, last: HashMap.Iterator<Key, T>): void;
    /**
     * @inheritDoc
     */
    dispatchEvent(event: HashMapCollection.Event<Key, T>): void;
    /**
     * @inheritDoc
     */
    refresh(): void;
    /**
     * @inheritDoc
     */
    refresh(it: HashMap.Iterator<Key, T>): void;
    /**
     * @inheritDoc
     */
    refresh(first: HashMap.Iterator<Key, T>, last: HashMap.Iterator<Key, T>): void;
    /**
     * @inheritDoc
     */
    hasEventListener(type: CollectionEvent.Type): boolean;
    /**
     * @inheritDoc
     */
    addEventListener(type: CollectionEvent.Type, listener: HashMapCollection.Listener<Key, T>): void;
    /**
     * @inheritDoc
     */
    removeEventListener(type: CollectionEvent.Type, listener: HashMapCollection.Listener<Key, T>): void;
}
export declare namespace HashMapCollection {
    type Event<Key, T> = CollectionEvent<Entry<Key, T>, HashMap<Key, T>, HashMap.Iterator<Key, T>, HashMap.ReverseIterator<Key, T>>;
    type Listener<Key, T> = CollectionEvent.Listener<Entry<Key, T>, HashMap<Key, T>, HashMap.Iterator<Key, T>, HashMap.ReverseIterator<Key, T>>;
    const Event: typeof CollectionEvent;
    export import Iterator = HashMap.Iterator;
    export import ReverseIterator = HashMap.ReverseIterator;
}
//# sourceMappingURL=HashMapCollection.d.ts.map