import { TreeMap } from "tstl/container/TreeMap";
import { Entry } from "tstl/utility/Entry";
import { ICollection } from "../basic/ICollection";
import { CollectionEvent } from "../basic/CollectionEvent";
import "./internal";
export declare class TreeMapCollection<Key, T> extends TreeMap<Key, T> implements ICollection<Entry<Key, T>, TreeMap<Key, T>, TreeMap.Iterator<Key, T>, TreeMap.ReverseIterator<Key, T>> {
    /**
     * @hidden
     */
    private dispatcher_;
    clear(): void;
    /**
     * @hidden
     */
    protected _Handle_insert(first: TreeMap.Iterator<Key, T>, last: TreeMap.Iterator<Key, T>): void;
    /**
     * @hidden
     */
    protected _Handle_erase(first: TreeMap.Iterator<Key, T>, last: TreeMap.Iterator<Key, T>): void;
    /**
     * @inheritDoc
     */
    dispatchEvent(event: TreeMapCollection.Event<Key, T>): void;
    /**
     * @inheritDoc
     */
    refresh(): void;
    /**
     * @inheritDoc
     */
    refresh(it: TreeMap.Iterator<Key, T>): void;
    /**
     * @inheritDoc
     */
    refresh(first: TreeMap.Iterator<Key, T>, last: TreeMap.Iterator<Key, T>): void;
    /**
     * @inheritDoc
     */
    hasEventListener(type: CollectionEvent.Type): boolean;
    /**
     * @inheritDoc
     */
    addEventListener(type: CollectionEvent.Type, listener: TreeMapCollection.Listener<Key, T>): void;
    /**
     * @inheritDoc
     */
    removeEventListener(type: CollectionEvent.Type, listener: TreeMapCollection.Listener<Key, T>): void;
}
export declare namespace TreeMapCollection {
    type Event<Key, T> = CollectionEvent<Entry<Key, T>, TreeMap<Key, T>, TreeMap.Iterator<Key, T>, TreeMap.ReverseIterator<Key, T>>;
    type Listener<Key, T> = CollectionEvent.Listener<Entry<Key, T>, TreeMap<Key, T>, TreeMap.Iterator<Key, T>, TreeMap.ReverseIterator<Key, T>>;
    const Event: typeof CollectionEvent;
    export import Iterator = TreeMap.Iterator;
    export import ReverseIterator = TreeMap.ReverseIterator;
}
//# sourceMappingURL=TreeMapCollection.d.ts.map