import { TreeSet } from "tstl/container/TreeSet";
import { ICollection } from "../basic/ICollection";
import { CollectionEvent } from "../basic/CollectionEvent";
export declare class TreeSetCollection<T> extends TreeSet<T> implements ICollection<T, TreeSet<T>, TreeSet.Iterator<T>, TreeSet.ReverseIterator<T>> {
    /**
     * @hidden
     */
    private dispatcher_;
    clear(): void;
    /**
     * @hidden
     */
    protected _Handle_insert(first: TreeSet.Iterator<T>, last: TreeSet.Iterator<T>): void;
    /**
     * @hidden
     */
    protected _Handle_erase(first: TreeSet.Iterator<T>, last: TreeSet.Iterator<T>): void;
    /**
     * @inheritDoc
     */
    dispatchEvent(event: TreeSetCollection.Event<T>): void;
    /**
     * @inheritDoc
     */
    refresh(): void;
    /**
     * @inheritDoc
     */
    refresh(it: TreeSet.Iterator<T>): void;
    /**
     * @inheritDoc
     */
    refresh(first: TreeSet.Iterator<T>, last: TreeSet.Iterator<T>): void;
    /**
     * @inheritDoc
     */
    hasEventListener(type: CollectionEvent.Type): boolean;
    /**
     * @inheritDoc
     */
    addEventListener(type: CollectionEvent.Type, listener: TreeSetCollection.Listener<T>): void;
    /**
     * @inheritDoc
     */
    removeEventListener(type: CollectionEvent.Type, listener: TreeSetCollection.Listener<T>): void;
}
export declare namespace TreeSetCollection {
    type Event<T> = CollectionEvent<T, TreeSet<T>, TreeSet.Iterator<T>, TreeSet.ReverseIterator<T>>;
    type Listener<T> = CollectionEvent.Listener<T, TreeSet<T>, TreeSet.Iterator<T>, TreeSet.ReverseIterator<T>>;
    const Event: typeof CollectionEvent;
    export import Iterator = TreeSet.Iterator;
    export import ReverseIterator = TreeSet.ReverseIterator;
}
//# sourceMappingURL=TreeSetCollection.d.ts.map